source("global_parameters.R")
source("utils.R")

dat = read.table("../datasets/ABX.csv", header=T)

ABXParticipants = unique(as.character(dat$subject))
ABXGuitarPairs = unique(as.character(dat$cmp))

datABX = data.frame()
for (i in 1:length(ABXParticipants)){
    thisPart = ABXParticipants[i]
    for (j in 1:length(ABXGuitarPairs)){
        thisGuitarPair = ABXGuitarPairs[j]
        thisInputDF = dat[dat$subject == thisPart & dat$cmp==thisGuitarPair,]

        thisInputDF$A = as.character(thisInputDF$A)
        thisInputDF$B = as.character(thisInputDF$B)
        thisInputDF$X = as.character(thisInputDF$X)
        nTotA = length(thisInputDF[thisInputDF$A == thisInputDF$X, 'X'])
        nTotB = length(thisInputDF[thisInputDF$B == thisInputDF$X, 'X'])
        nCorrA = sum(thisInputDF[thisInputDF$A == thisInputDF$X, 'score'])
        nCorrB = sum(thisInputDF[thisInputDF$B == thisInputDF$X, 'score'])
        nIncorrA = nTotA - nCorrA
        nIncorrB = nTotB - nCorrB
        nCorr = sum(thisInputDF$score)
        nTot = length(thisInputDF$score)
        thisOutputDF = data.frame(subject=thisPart, cnd=thisGuitarPair, type=thisInputDF$type[1], yearsExp=thisInputDF$yearsExp[1], nCorrA=nCorrA, nIncorrA=nIncorrA, nTotA=nTotA, nCorrB=nCorrB, nIncorrB=nIncorrB, nTotB=nTotB)
        datABX = rbind(datABX, thisOutputDF)
    }
}

datABX$HR = datABX$nCorrA/datABX$nTotA
datABX$FA = datABX$nIncorrB/datABX$nTotB

datABX$dprime = numeric(length(datABX$subject))
for (i in 1:length(datABX$subject)){
    datABX$dprime[i] = dp_ABX_2N(datABX$nCorrA[i], datABX$nTotA[i], datABX$nIncorrB[i], datABX$nTotB[i], method="diff")
}
write.table(datABX, "../derived_datasets/ABX_dprime.csv", col.names=T, row.names=F) 
