## read in all data
dat = read.table("../derived_datasets/blinded_ratings_with_EFA_scores.csv", header=T)
##  find participants who complete both rating sessions
subjTwoSess = unique(as.character(dat[dat$rep == "second", "subject",]))
##
dat = dat[dat$subj %in% subjTwoSess,]
dat$subject = factor(dat$subj, exclude=NULL)
dat = dat[order(dat$subject, dat$guitar, dat$rep),]
## compute z scores
scales = names(dat)
scales = scales[-c(which(scales == "subject"), which(scales=="guitar"), which(scales=="type"), which(scales=="yearsExp"), which(scales=="rep"))]

for (s in 1:length(scales)){
    sMean = tapply(dat[, scales[s]], list(dat$rep, dat$subject), mean)
    sSD = tapply(dat[, scales[s]], list(dat$rep, dat$subject), sd)
    for (j in 1:length(dat$subject)){
        dat[j, paste(scales[s], "Z", sep="")] = ifelse(sSD[dat[j, "rep"], dat[j, "subject"]] == 0, 0, (dat[j, scales[s]] - sMean[dat[j, "rep"], dat[j, "subject"]]) / sSD[dat[j, "rep"], dat[j, "subject"]])
    }
}

datRep1 = dat[dat$rep=="first",]
datRep2 = dat[dat$rep=="second",]
datRep12 = datRep1
cNames = names(datRep1)[-c(1:5)]
for (i in 1:length(cNames)){
    thisCName = cNames[i]
    datRep12[, paste(thisCName, "2", sep="")] = datRep2[, thisCName]
}
datRep12$rep = NULL 

write.table(dat, "../derived_datasets/blinded_ratings_with_EFA_and_z_scores.csv", col.names=T, row.names=F)
write.table(datRep12, "../derived_datasets/blinded_ratings_rep1_rep2.csv", col.names=T, row.names=F)
